/*
 * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
 * Copyright (C)2020-2024 백고미(김태훈) All rights reserved.
 * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
 * TIP : 
 */
 
#pragma dynamic 131072 //Not enough space on the stack 방지

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <dhooks>
#include <timerex>
#include <SteamWorks>

#define SPEC 1
#define HUMAN 2
#define ZOMBIE 3

#define MOTHERCOUNT 210
#define SUPERMOTHERCOUNT 350

#define DEFAULTSPEED 190.0 //기본속도, 320을 초과할수없음.

#define bits_SUIT_DEVICE_SPRINT	0x00000001

int g_iWorldModel_StunStick;

enum struct round_data
{
	int score; //점수
	int readytimer;
	int zombietimer; //좀비선출타이머
	int endtimer; //게임끝난후(오버레이출력) 대기시간
	int winner;
	int min;
	int sec;
	int balance; //
	bool start; //false:시작전, true:시작후
	bool zombieborn; //좀비발생체크
}
round_data round;

enum struct player_data
{
	bool hero;
	bool zombie;
	bool healmode; //좀비힐모드
	bool usingskill; //스킬사용중 여부
	int healmodecount;
	int level;
	int range; //인간 및 좀비 분노
	float runtime; //좀비 스킬 쿨타임
	int runtimecount; //쿨타임카운트
}
player_data ply[MAXPLAYERS+1];

enum struct keyset_data {
	bool E; //
	bool R;
	bool C; //나침반
	bool U; 
	bool Num1; //1번
	bool Num2; //2번
	bool Num3; //3번
	bool Alt;
	bool Duck; 
	bool Shift;
	bool F; //플래쉬
	bool G;
	bool V;
	bool Jump; //IN_JUMP
	bool Tab;
	bool Attack1;
	bool Attack2;
}
keyset_data KeySet[MAXPLAYERS+1];

//좀비 진화단계
enum Evo
{
	NoHost = 0, //일반좀비
	Host, //호스트
	Mother //저거넛
}
float ZombieSpeed[Evo] = {230.0, 270.0, 320.0};
//좀비 종류
enum ZombieType
{
	Regular = 0, //일반
	HostReglar,
	Girl //소녀
}
//인간 종류
enum
{
	NoHero, //일반인
	Hero //영웅
}
//고정 스프라이트 종류
enum Sprite
{
	BloodKnife = 0, //피의칼날
	Sprint, //질주
	Trademark, //영웅, 저거넛
	KillConfirm //확인사살
}

int MyWeapon;
char HumanSkin[][] = {
	"models/breen.mdl",
	"models/breen.mdl",
	"models/breen.mdl",
	"models/breen.mdl",
	"models/breen.mdl",
	"models/breen.mdl"
};
char ZombieSkin[][] = {
	// models/player/techknow/host/host.mdl
	"models/stalker.mdl", //누가했는지 호스트랑 cavity 반대로 적용해놈 ㅅㅂ
	"models/stalker.mdl"
	// "models/player/techknow/cavity/cavity.mdl",
};

//무기 배열:
char Weapon_Vector[][][] =
{
  //첫번째 배열 : 무기 이름
  //두번째 배열 : 넉백 크기
  {"weapon_crowbar", "900.0"},
  {"weapon_stunstick", "1250.0"},
  {"weapon_pistol", "80.0"},
  {"weapon_357", "100.0"},
  
  {"weapon_smg1", "165.0"},
  {"weapon_ar2", "145.0"},
  
  {"weapon_shotgun", "550.0"},
  {"weapon_crossbow", "500.0"},
  
  {"weapon_frag", "250.0"},
  {"weapon_rpg", "750.0"},
  {"weapon_slam", "400.0"}
};

int g_BeamSprite;
int footstepsprite;
int gBlood1;
int gBloodDrop1;
int Envsprite[MAXPLAYERS+1][4];

Handle Hud_Rage[MAXPLAYERS+1];
int HumanRage;

int keybuffering[MAXPLAYERS+1];

public void OnPluginStart()
{
	HookEvent("player_spawn", player_spawn);
	HookEvent("player_death", player_death, EventHookMode_Pre);
	HookEvent("player_hurt", Player_Hurt);
	
	HookEvent("round_start", Round_Start, EventHookMode_Pre);
	
	RegConsoleCmd("kill", Blocking);
	RegConsoleCmd("explode", Blocking);
	RegConsoleCmd("spectate", Blocking);
	RegConsoleCmd("jointeam", Blocking);
	
	RegConsoleCmd("getspeed", getspeed);
	RegConsoleCmd("setspeed", setspeed);
	
	AddNormalSoundHook(SoundCallBackHook); //사운드 훅
	
	MyWeapon = FindSendPropInfo("CBasePlayer", "m_hMyWeapons");
}
public void OnMapStart()
{
	ItemRemoveEntity();
	InitializeRound();
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrContains(map, "gtm", false) != -1) SetFailState("[Plugin Unload] : GTM map is for only titan mod.");
	else if(StrContains(map, "z_umi", false) != -1) SetFailState("[Plugin Unload] : z_umi map is for only Fishing mod.");
	char namebuffer[256]; Format(namebuffer, sizeof(namebuffer), "DeathRow Zombie Survival");
	ServerCommand("hostname \"%s\"", namebuffer); //서버제목
	
	SteamWorks_SetGameDescription("Zombie Survival");
	
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		Hud_Rage[Client] = CreateHudSynchronizer(); //
	}
	
	g_BeamSprite = PrecacheModel("materials/sprites/laser.vmt");
	footstepsprite = PrecacheModel("materials/sprites/steam1.vmt");
	gBlood1 = PrecacheModel("sprites/bloodspray.vmt");
	gBloodDrop1 = PrecacheModel("sprites/blood.vmt");
	
	g_iWorldModel_StunStick = PrecacheModel("models/giant/w_super_hard_blade.mdl", true);

	CreateTimerEx(1.0, MapIntCount, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}
public void OnConfigsExecuted()
{
	PrintToServer("Zombie Survival loading completed %d %d %s | %d", ZombieType:Regular, ZombieType:Girl, ZombieSkin[ZombieType:Regular], sizeof(Weapon_Vector));
}
public void InitializeRound()
{
	round.readytimer = -1;
	round.endtimer = -1;
	round.start = false;
	round.zombieborn = false;
	
	HumanRage = 0;
	
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngame(Client))
		{
			ply[Client].hero = false;
			ply[Client].zombie = false;
			ply[Client].range = 0;
		}
	}
}

public void OnEntityCreated(int entity, const char[] classname)
{
	if(IsValidEdict(entity) && IsValidEntity(entity))
	{
		// CreateTimer(1.0, CheckEntityOwner, EntIndexToEntRef(entity));
		
		//[모델경로] models/crossbow_bolt.mdl [클래스이름] crossbow_bolt
		if(StrEqual(classname, "crossbow_bolt", false))
		{
			float origin[3]; GetEntPropVector(entity, Prop_Send, "m_vecOrigin", origin);
			TE_SetupBeamRingPoint(origin, 100.0, 250.0, g_BeamSprite, footstepsprite, 0, 30, 1.4, 10.0, 0.0, {255, 0, 0, 255}, 1, 0);
			TE_SendToAll();
			TE_SetupBeamRingPoint(origin, 10.0, 250.0, g_BeamSprite, footstepsprite, 0, 30, 1.4, 5.0, 0.0, {255, 0, 0, 255}, 105, 0);
			TE_SendToAll();
			
			int Color[4];
			Color[0] = view_as<int>(GetRandomInt(0, 255));
			Color[1] = view_as<int>(GetRandomInt(0, 255));
			Color[2] = view_as<int>(GetRandomInt(0, 255));
			Color[3] = view_as<int>(255);
			
			// TE_SetupBeamFollow(int EntIndex, int ModelIndex, int HaloIndex, float Life, float Width, float EndWidth, int FadeLength, const int Color[4])
			TE_SetupBeamFollow(entity, g_BeamSprite, g_BeamSprite, 5.0, 5.0, 0.1, 5, Color);
			TE_SendToAll();
			
			// SDKHook(entity, SDKHook_StartTouch, BoltTouch);
		}
	}
}

public void OnEntityDestroyed(int entity)
{
	if(IsValidEdict(entity) && IsValidEntity(entity))
	{
		
	}
}

public void OnClientPutInServer(int Client)
{
	if(IsClientConnectedIngame(Client))
	{
		if(round.readytimer != -1)
		{
			if(IsPlayerAlive(Client))
			{
				// SetProtection(Client);
				// SetInitializePlayer(Client, false);
			}
		}
		else
		{
			
		}
		
		if(round.zombieborn) //좀비 선발후
		{
			CreateTimer(0.1, SetSpectate, Client);
			
		}
	}
	
	SDKHook(Client, SDKHook_PreThink, PreThinkHook);
	SDKHook(Client, SDKHook_OnTakeDamage, OnTakeDamage);
	SDKHook(Client, SDKHook_WeaponSwitch, OnWeaponSwitch);
	// SDKHook(Client, SDKHook_WeaponCanUse, WeaponCanUse);
}
public void OnClientDisconnect(int Client)
{
	SDKUnhook(Client, SDKHook_PreThink, PreThinkHook);
	
	for(int X = MaxClients, Y = GetMaxEntities(); X <= Y; X++)
	{
		if(IsValidEdict(X) && IsValidEntity(X))
		{
			
		}
	}
	for(int i = 0; i < 4; i++) RemoveSprite(Client, i);
	
}

public Action OnPlayerRunCmd(int Client, int &buttons, int &impulse, float vel[3], float angles[3], int &weapon, int &subtype, int &cmdnum, int &tickcount, int &seed, int mouse[2])
{
	if(!IsClientConnectedIngame(Client)) return Plugin_Continue;
	if(impulse == 51) return Plugin_Handled;
	
	int iActiveWeapon = GetEntPropEnt(Client, Prop_Data, "m_hActiveWeapon");
	if(iActiveWeapon != -1)
	{
		char sWeapon[64];
		GetEdictClassname(iActiveWeapon, sWeapon, sizeof(sWeapon));

		if(StrEqual(sWeapon, "weapon_stunstick"))
			if(GetClientTeam(Client) == HUMAN)
				SetEntProp(iActiveWeapon, Prop_Send, "m_iWorldModelIndex", g_iWorldModel_StunStick);
	}
	
	if(GetClientTeam(Client) == ZOMBIE)
	{
		//unlimited Run
		int m_bitsActiveDevices = GetEntProp(Client, Prop_Send, "m_bitsActiveDevices");
		if (m_bitsActiveDevices & bits_SUIT_DEVICE_SPRINT)
		{
			SetEntPropFloat(Client, Prop_Data, "m_flSuitPowerLoad", 0.0);
			SetEntProp(Client, Prop_Send, "m_bitsActiveDevices", m_bitsActiveDevices & ~bits_SUIT_DEVICE_SPRINT);
		}
		buttons &= ~IN_SPEED; //쉬프트방지
		//Hide Hud
		//( 1<<3 ) : Hide health & armor / suit battery
		//( 1<<8 ) : Hide crosshairs
		// SetEntProp(Client, Prop_Send, "m_iHideHUD", ( 1<<3 ) | ( 1<<8 ) | 64);
	}
	//한번체크
	if(buttons & IN_USE)
	{
		if(!KeySet[Client].E)
		{
			if(!IsFakeClient(Client))
			{
				// PrintToChat(Client, "E키");
			}
			KeySet[Client].E = true;
		}
	}
	else KeySet[Client].E = false;
	
	if(buttons & IN_RELOAD)
	{
		if(!KeySet[Client].R)
		{
			if(!IsFakeClient(Client))
			{
				ZombieSkillUse(Client);
			}
			KeySet[Client].R = true;
		}
	}
	else KeySet[Client].R = false;
	
	
	if(buttons & IN_ATTACK)
	{
		if(!KeySet[Client].Attack1)
		{
			if(!IsFakeClient(Client))
			{
				
			}
			KeySet[Client].Attack1 = true;
		}
	}
	else KeySet[Client].Attack1 = false;
	
	if(buttons & IN_ATTACK2)
	{
		if(!KeySet[Client].Attack2)
		{
			if(!IsFakeClient(Client))
			{
				
			}
			KeySet[Client].Attack2 = true;
		}
	}
	else KeySet[Client].Attack2 = false;
	
	// isChatAll("%d", buttons);
	if(GetClientTeam(Client) == ZOMBIE)
	{
		// if(buttons & IN_SPEED)
		// {
			// buttons &= ~IN_SPEED;
		// }
		ForceChangeKnife(Client);
	}
	
	return Plugin_Changed;
}

// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
// * 훅 : Hooks. 
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
public Action player_spawn(Handle event, const char[] name, bool dontBroadcast)
{
	int Client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(IsClientConnectedIngame(Client))
	{
		CreateTimer(0.0, InitializeWeapon, Client); //무기제거
		CreateTimer(0.2, GiveKnife, Client); //무기지급
		
		ply[Client].runtime = GetGameTime();
		
		if(!round.zombieborn) //좀비 선발전
		{
			ply[Client].hero = false;
			ply[Client].zombie = false;
			ply[Client].level = 0;
			
			SetEntProp(Client, Prop_Send, "m_iTeamNum", HUMAN);
			SetEntProp(Client, Prop_Data, "m_iHealth", 1000, 1); SetClientMaxHealth(Client, 1000);
			SetEntityModel(Client, HumanSkin[GetRandomInt(0, sizeof(HumanSkin) - 1)]);
		}
		else
		{
			if(ply[Client].zombie)
			{
				if(ply[Client].level == view_as<int>(Evo:NoHost)) 
				{
					SetEntProp(Client, Prop_Data, "m_iHealth", 3000, 1); SetClientMaxHealth(Client, 3000);
					SetEntityModel(Client, ZombieSkin[ZombieType:Regular]);
					SetSpeed(Client, ZombieSpeed[Evo:NoHost]);
				}
				else if(ply[Client].level == view_as<int>(Evo:Host)) 
				{
					SetEntProp(Client, Prop_Data, "m_iHealth", 7000, 1); SetClientMaxHealth(Client, 7000);
					SetEntityModel(Client, "models/stalker.mdl");
					SetSpeed(Client, ZombieSpeed[Evo:Host]);
				}
				else if(ply[Client].level == view_as<int>(Evo:Mother)) 
				{
					SetEntProp(Client, Prop_Data, "m_iHealth", 14000, 1); SetClientMaxHealth(Client, 14000);
					SetEntityModel(Client, "models/stalker.mdl");
					SetSpeed(Client, ZombieSpeed[Evo:Mother]);
				}
			}
			if(GetClientTeam(Client) == HUMAN)
			{
				char RageString[128]; Format(RageString, sizeof(RageString), "r_screenoverlay icon/f_%d.vmt", HumanRage);
				//ClientCommand(Client, RageString);
			}
		}
		
		if(!IsFakeClient(Client)) //인간
		{
			// SetEntityModel(Client, "models/player/Neo_heavy.mdl"); //지우기
		}
		if(IsFakeClient(Client)) //봇
		{
			
		}
	}
	
	return Plugin_Continue;
}
public Action player_death(Handle event, const char[] name, bool dontBroadcast)
{
	char weapon[20]; GetEventString(event, "weapon", weapon, sizeof(weapon));
	
	int Attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	int Client = GetClientOfUserId(GetEventInt(event, "userid"));

	if(IsClientConnectedIngame(Client))
	{
		if(GetClientTeam(Client) == HUMAN)
		{
			ply[Client].hero = false;
			ply[Client].zombie = false;
			SetEntProp(Client, Prop_Send, "m_iTeamNum", SPEC);
			ChangeClientTeam(Client, SPEC);
		}
		else if(GetClientTeam(Client) == ZOMBIE)
		{
			if(GetClientTeam(Attacker) == HUMAN)
			{
				ply[Client].range += 30;
				HumanRage++;
				if(HumanRage > 13) HumanRage = 13;
				for(int X = 1; X <= MaxClients; X++)
				{
					if(IsClientConnectedIngame(X) && GetClientTeam(X) == HUMAN)
					{
						char RageString[128]; Format(RageString, sizeof(RageString), "r_screenoverlay icon/f_%d.vmt", HumanRage);
						//ClientCommand(X, RageString);
					}
				}
				
				float vec[3];
				GetClientAbsOrigin(Client, vec);
				vec[2] += 5.0;
				CreateVMT(vec, "materials/icon/zombierespawn.vmt", 0.3, "10", 5.0);
				
				Sound("misc/powerup.wav");
			}
			
			
		}
		
		for(int i = 0; i < 4; i++) RemoveSprite(Client, i);
	}
	
	return Plugin_Continue;
}
public Action Player_Hurt(Event event, const char[] name, bool dontBroadcast)
{
 	int Client = GetClientOfUserId(GetEventInt(event, "userid"));
	int Attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	// int iDamage = GetEventInt(event, "dmg_health"); 
	int iHitgroup = GetEventInt(event, "hitgroup");
	if(IsClientConnectedIngame(Client))
	{
		char weapon[32]; GetEventString(event, "weapon", weapon, sizeof(weapon));
		
		//Health[Attacker] = GetClientHealth(Attacker);
		//공격
		if(StrEqual(weapon, "knife")) 
		{
			if(!IsFakeClient(Attacker))
			{
				//
			}
		}
		
		if(iHitgroup == 1) //헤드
		{

		}
		if(Attacker > 0 && Attacker <= MaxClients)
		{
			RageHud(Client);
			if(GetClientTeam(Client) == ZOMBIE)
			{
				ply[Client].range++;

				if(StrEqual(weapon, "weapon_crossbow", false)) ply[Client].range += 30;
				else if(StrEqual(weapon, "weapon_slam", false)) ply[Client].range += 5;
				else if(StrEqual(weapon, "weapon_rpg", false)) ply[Client].range += 20;
				else if(StrEqual(weapon, "weapon_357", false)) ply[Client].range += 2;
				
				if(ply[Client].level == view_as<int>(Evo:NoHost)) //일반 > 숙주
				{
					if(ply[Client].range >= MOTHERCOUNT)
					{
						ply[Client].range = 0;
						ply[Client].level = view_as<int>(Evo:Host);
						SetEntProp(Client, Prop_Data, "m_iHealth", 7000, 1); SetClientMaxHealth(Client, 7000);
						SetEntityModel(Client, "models/stalker.mdl");
						PrintToChat(Client, "\x04Evolved into a host.");
						EmitSoundToAll("misc/zombi_evolution.wav", Client, SNDCHAN_AUTO, 100);
						SetSpeed(Client, ZombieSpeed[Evo:Host]);
					}
					else 
					{
						if(GetSpeed(Client) <= ZombieSpeed[Evo:NoHost]) SetSpeed(Client, ZombieSpeed[Evo:NoHost]);
					}
				}
				else if(ply[Client].level == view_as<int>(Evo:Host)) //숙주 > 저거넛
				{
					if(ply[Client].range >= SUPERMOTHERCOUNT)
					{
						ply[Client].range = 0;
						ply[Client].level = view_as<int>(Evo:Mother);
						SetEntProp(Client, Prop_Data, "m_iHealth", 14000, 1); SetClientMaxHealth(Client, 14000);
						// SetEntityModel(Client, "models/stalker.mdl");
						PrintToChat(Client, "\x04Evolved into a juggernaut.");
						EmitSoundToAll("misc/zombi_evolution.wav", Client, SNDCHAN_AUTO, 100);
						SetSpeed(Client, ZombieSpeed[Evo:Mother]);
						
						CreateSprite(Client, "materials/zombie/zombie_s_fix_final.vmt", 65.0, view_as<int>(Sprite:Trademark));
					}
				}
				
				ply[Client].healmode = false;
				ply[Client].healmodecount = 0;
				
				SetSpeed(Client, 120.0); //경직
				CreateTimerEx(0.1, getBackSpeed, Client);
				
				float vEntPosition[3], vAngle[3];
				GetEntPropVector(Client, Prop_Send, "m_vecOrigin", vEntPosition);
				vEntPosition[2] += 50.0;
	
				vAngle[0] = GetRandomFloat(-3.0, 3.0);
				vAngle[1] = GetRandomFloat(-3.0, 3.0);
				vAngle[2] = GetRandomFloat(-3.0, 3.0);
				
				// Blood
				TE_SetupBloodSprite(vEntPosition, vAngle, {255, 0, 0, 255}, 5, gBlood1, gBloodDrop1);
				TE_SendToAll();
				TE_SetupBloodSprite(vEntPosition, vAngle, {255, 0, 0, 255}, 6, gBlood1, gBloodDrop1);
				TE_SendToAll();
				TE_SetupBloodSprite(vEntPosition, vAngle, {255, 0, 0, 255}, 7, gBlood1, gBloodDrop1);
				TE_SendToAll();
				TE_SetupBloodSprite(vEntPosition, vAngle, {255, 0, 0, 255}, 8, gBlood1, gBloodDrop1);
				TE_SendToAll();
			}
		}
	}
	return Plugin_Changed;
}
public Action getBackSpeed(any Client)
{
	if(GetClientTeam(Client) == ZOMBIE)
	{
		SetSpeed(Client, ZombieSpeed[view_as<int>(ply[Client].level)]);
	}
	return Plugin_Continue;
}


public Action Round_Start(Handle event, const char[] name, bool dontBroadcast)
{
	//Snowfall();
	ItemRemoveEntity();
	InitializeRound();
	//PickTitan();
	// PrintToChatAll("라운드스타트");
	// PrintToChatAll("\x04라운드 시작");
	
	return Plugin_Continue;
}

public Action:Blocking(Client, Args)
{
	if(!IsClientAdmin(Client))
	{
		Sound("buttons/button10.wav", _, Client);
		return Plugin_Handled;
	}
	return Plugin_Continue;
	
}

public Action getspeed(int Client, int Args)
{
	float spd = GetSpeed(Client);
	PrintToChat(Client, "\x04Speed : %.2f", spd);
	return Plugin_Handled;
}
public Action setspeed(int Client, int Args)
{
	if(Args < 1)
	{
		if(IsClientConnectedIngame(Client)) PrintToChat(Client, "\x01[\x04-\x01] Usage: sm_setspeed <speed>");
		return Plugin_Handled;
	}
	char Cmds[32]; GetCmdArg(1, Cmds, sizeof(Cmds));
	float spd = StringToFloat(Cmds);
	SetSpeed(Client, spd);
	
	return Plugin_Handled;
}

public void PreThinkHook(int Client)
{
	int buttons = GetClientButtons(Client);
	if(IsClientConnectedIngame(Client))
	{
		if(GetClientTeam(Client) == ZOMBIE)
		{
			if(!(keybuffering[Client] & IN_JUMP))
			{
				if((buttons & IN_JUMP) && (GetEntityFlags(Client) & FL_ONGROUND))
				{
					SetClientButtons(Client, buttons & ~IN_JUMP);
					keybuffering[Client] = keybuffering[Client] | IN_JUMP;
					float playerspeed[3];
					GetEntPropVector(Client, Prop_Data, "m_vecVelocity", playerspeed);

					playerspeed[2] = playerspeed[2] + 110;
					
					TeleportEntity(Client, NULL_VECTOR, NULL_VECTOR, playerspeed);
				}
	
			}
			else if(!(buttons & IN_JUMP) && (GetEntityFlags(Client) & FL_ONGROUND))
			{
				keybuffering[Client] = keybuffering[Client] & ~IN_JUMP;
			}
		}
		else if(GetClientTeam(Client) == HUMAN)
		{
			if(!(keybuffering[Client] & IN_JUMP))
			{
				if((buttons & IN_JUMP) && (GetEntityFlags(Client) & FL_ONGROUND))
				{
					SetClientButtons(Client, buttons & ~IN_JUMP);
					keybuffering[Client] = keybuffering[Client] | IN_JUMP;
					float playerspeed[3];
					GetEntPropVector(Client, Prop_Data, "m_vecVelocity", playerspeed);

					playerspeed[2] = playerspeed[2] + 40;
					
					TeleportEntity(Client, NULL_VECTOR, NULL_VECTOR, playerspeed);
				}
	
			}
			else if(!(buttons & IN_JUMP) && (GetEntityFlags(Client) & FL_ONGROUND))
			{
				keybuffering[Client] = keybuffering[Client] & ~IN_JUMP;
			}
		}
	}
	
}

public Action OnTakeDamage(int Client, int &Attacker, int &inflictor, float &damage, int &damagetype, int &i_weapon, float damageForce[3], float damagePosition[3])
{
	if(IsClientConnectedIngameAlive(Client) && IsClientConnectedIngameAlive(Attacker))
	{
		char s_Weapon[256], weapon[32];
		GetEdictClassname(inflictor, s_Weapon, sizeof(s_Weapon));
		GetClientWeapon(Attacker, weapon, sizeof(weapon));
		
		// PrintToChatAll("type : %d", damagetype);
		
		if(StrEqual(weapon, "weapon_ar2", false))
		{
			if(damagetype == 67108865) //코어볼 타입
			{
				damage = 50.0;
				if(GetClientTeam(Client) == ZOMBIE) ply[Client].range += 5;
			}
		}
		
		if(GetClientTeam(Attacker) == ZOMBIE)
		{
			if(GetClientTeam(Client) != ZOMBIE) //인간팀 감염시
			{
				// PrintToChatAll("데미지 타입 : %d", damagetype);
				if(damagetype & 128) //근접만
				{
					ply[Attacker].range += 30;
					
					char InfectSnd[128], InfectAll[128];
					int rand = GetRandomInt(1, 2);
					Format(InfectSnd, sizeof(InfectSnd), "misc/human_death_0%d.wav", rand);
					Format(InfectAll, sizeof(InfectAll), "misc/zombi_coming_%d.wav", rand);
					
					EmitSoundToAll(InfectSnd, Client, SNDCHAN_AUTO, 100);
					EmitSoundToAll(InfectAll);
					ply[Client].zombie = true;
					ply[Client].level = view_as<int>(Evo:NoHost);
					SetEntProp(Client, Prop_Send, "m_iTeamNum", ZOMBIE);
					SetEntProp(Client, Prop_Data, "m_iHealth", 3000, 1);  SetClientMaxHealth(Client, 3000);
					
					CreateTimer(0.0, InitializeWeapon, Client); //무기제거
					CreateTimer(0.2, GiveKnife, Client); //무기지급
					
					SetEntityModel(Client, ZombieSkin[ZombieType:Regular]);
					
					for(int i = 0; i < 4; i++) RemoveSprite(Client, i);
					
					Handle Devent = CreateEvent("player_death");
					SetEventInt(Devent, "userid", GetClientUserId(Client));
					SetEventInt(Devent, "attacker", GetClientUserId(Attacker));
					SetEventString(Devent, "weapon", "crowbar");
					SetEventBool(Devent, "headshot", true);
					FireEvent(Devent, false);
					// delete Devent;
					
					//라운드 종료 체크
					round.winner = GetWinnerTeam();
					if(round.winner != -1) Victory(round.winner);
				}
			}
			else if(GetClientTeam(Client) == ZOMBIE) //같은팀 공격
			{
				//좀비 맞는소리
				ZombieHurtSound(Client);
			}
			
		}
		
		if(GetClientTeam(Attacker) == HUMAN)
		{
			if(GetClientTeam(Client) == HUMAN) //인간팀킬시도
			{
				damage /= 4;
			}
			else if(GetClientTeam(Client) == ZOMBIE) //좀비공격
			{
				ZombieHurtSound(Client);
				
				float AttackerPosition[3], ClientPosition[3], Vector[3];

				GetClientEyePosition(Attacker, AttackerPosition);
				GetClientEyePosition(Client, ClientPosition);

				MakeVectorFromPoints(AttackerPosition, ClientPosition, Vector);
				NormalizeVector(Vector, Vector);

				for(int X; X < sizeof(Weapon_Vector); X++)
				{
					if(StrEqual(weapon, Weapon_Vector[X][0], false))
					{
						if(ply[Client].usingskill)
						{
							if(ply[Client].zombie && ply[Client].level == view_as<int>(Evo:Mother)) ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]) * 0.25);
							else if(ply[Client].zombie && ply[Client].level == view_as<int>(Evo:Host)) ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]) * 0.65);
							else ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]) * 0.8);
						}
						else 
						{
							if(ply[Client].zombie && ply[Client].level == view_as<int>(Evo:Mother)) ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]) * 0.5);
							else if(ply[Client].zombie && ply[Client].level == view_as<int>(Evo:Host)) ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]) * 0.9);
							else ScaleVector(Vector, StringToFloat(Weapon_Vector[X][1]));
						}
						
						// PrintToChatAll("%s : %.1f", Weapon_Vector[X][0], StringToFloat(Weapon_Vector[X][1]));
					}
				}

				TeleportEntity(Client, NULL_VECTOR, NULL_VECTOR, Vector);
				
				if(StrEqual(weapon, "weapon_crowbar", false)
				|| StrEqual(weapon, "weapon_stunstick", false))
				{
					damage *= 30.0; //25
					// Sound("physics/glass/glass_impact_bullet4.wav");
				}
				damage *= 1.0 + (HumanRage * 0.15);
			}
			
			PrintCenterText(Attacker, "-%d HP", FloatToInt(damage));
		}
	}
	return Plugin_Changed;
}
public void ZombieHurtSound(int Client)
{
	if(IsClientConnectedIngame(Client))
	{
		//좀비 맞는소리
		char Sound_String[256];
		Format(Sound_String, sizeof(Sound_String), "misc/zombi_hurt_0%i.wav", GetRandomInt(1, 2));
		EmitSoundToAll(Sound_String, Client, SNDCHAN_BODY);
	}
}


public Action OnWeaponSwitch(int Client, int Weapon)
{
	/* if(IsClientConnectedIngameAlive(Client))
	{
		char WeaponClass[32];
		GetEdictClassname(Weapon, WeaponClass, sizeof(WeaponClass));

		if(GetClientTeam(Client) == ZOMBIE)
		{
			if(!StrEqual(WeaponClass, "weapon_crowbar", false)) return Plugin_Handled;
		}
	}
	return Plugin_Continue; */
	if(IsClientConnectedIngameAlive(Client))
	{
		if(GetClientTeam(Client) == ZOMBIE)
		{
			int Offset = FindSendPropInfo("CHL2MP_Player", "m_hMyWeapons");
			int maxWeapons = GetEntPropArraySize(Client, Prop_Data, "m_hMyWeapons");
			for(int X = 4; X <= maxWeapons; X += 4)
			{
				int WeaponId = GetEntDataEnt2(Client, Offset + X);
				if(!IsValidEdict(WeaponId) || !IsValidEntity(WeaponId))
					continue;
				
				if(WeaponId != Weapon)
				{
					RemovePlayerItem(Client, WeaponId);
					RemoveEdict(WeaponId);
				}
				continue;
			}
			
			char WeaponClass[32];
			GetEdictClassname(Weapon, WeaponClass, sizeof(WeaponClass));
			if(!StrEqual(WeaponClass, "weapon_crowbar", false))
			{
				CreateTimer(0.1, FixHoldWeapon, Weapon, TIMER_FLAG_NO_MAPCHANGE);
				return Plugin_Continue; //컨티뉴 하면 깔끔사용은 가능하지만 총 쏴짐 시발
				// return Plugin_Handled;
			}
		}
		else if(GetClientTeam(Client) == HUMAN)
		{
			char Weapons[32];
			GetClientWeapon(Client, Weapons, sizeof(Weapons));
			int weap = GetEntPropEnt(Client, Prop_Data, "m_hActiveWeapon");
			
			if(StrEqual(Weapons, "weapon_crossbow", false))
			{
				SetEntProp(weap, Prop_Data, "m_iClip1", 1000);
			}
		}
	}
	return Plugin_Continue;
}
public Action FixHoldWeapon(Handle Timer, int Weapon) //무기제거
{
	if(!IsValidEdict(Weapon) || !IsValidEntity(Weapon))
		return Plugin_Stop;
	
	int Client = GetEntPropEnt(Weapon, Prop_Data, "m_hOwnerEntity");
	if(IsClientConnectedIngameAlive(Client))
	{
		int item = GivePlayerItem(Client, "weapon_crowbar");
		if(item != -1)
		{
			FakeClientCommandEx(Client, "use weapon_crowbar");
			RemovePlayerItem(Client, Weapon);
			RemoveEdict(Weapon);
		}
	}
	return Plugin_Stop;
}

public Action WeaponCanUse(int Client, int weapons) //무기 못먹게도할수있는 훅
{
	if(IsClientConnectedIngame(Client) && GetClientTeam(Client) == ZOMBIE)
	{
		if(IsValidEntity(weapons) && IsValidEdict(weapons))
		{
			char Weapon[32];
			GetEdictClassname(weapons, Weapon, sizeof(Weapon));
			//new String:BotName[64];
			//GetClientName(Client, BotName, sizeof(BotName));
			
			if(!StrEqual(Weapon, "weapon_crowbar") && !StrEqual(Weapon, "weapon_stunstick"))
			{
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}
public Action:SoundCallBackHook(clients[64], &numClients, String:sample[PLATFORM_MAX_PATH], &entity, &channel, &Float:volume, &level, &pitch, &flags)
{
	if (strncmp(sample, "weapons", 7) == 0 || strncmp(sample[1], "weapons", 7) == 0)
	{
		//PrintToChatAll("%s", sample);
		//크로우바
		//- 휘두를때+맞힐때 : weapons/iceaxe/iceaxe_swing1.wav
		
		//스턴스틱
		//- 꺼낼때 : weapons/stunstick/spark1.wav , 2, 3
		//- 휘두를때 : weapons/stunstick/stunstick_swing1.wav , 2
		//- 맞힐때 : weapons/stunstick/stunstick_fleshhit1.wav , 2
		
		//크로스보우
		//- 발사 : weapons/crossbow/fire1.wav
		//- 총알날라감 : weapons/crossbow/bolt_fly4.wav
		//- 맞음 : weapons/crossbow/hit1.wav
		//- 재장전 : weapons/crossbow/bolt_load1.wav
		
		//PrintToChatAll("%s", sample);
	}
	//크로우바
	/* if(StrEqual(sample, "weapons/iceaxe/iceaxe_swing1.wav"))
	{
		if(IsValidEntity(entity) && entity != -1)
		{
			if(!IsClientConnectedIngame(entity)) return Plugin_Handled;
			
			if(GetClientTeam(entity) != ZOMBIE)
			{
				char Sound_String[256];
				Format(Sound_String, sizeof(Sound_String), "misc/zombi_swing_%i.wav", GetRandomInt(1, 3));
				// EmitSoundToAll(Sound_String, client);
				Sound(Sound_String, _, entity, true);
				Sound(Sound_String, _, entity); //개인만들림
				
				
			}
		}
		return Plugin_Handled;
	} */
	//weapon_fire:크로우바, 스턴스틱
	if(StrEqual(sample, "weapons/iceaxe/iceaxe_swing1.wav") 
	|| StrEqual(sample, "weapons/stunstick/stunstick_swing1.wav") 
	|| StrEqual(sample, "weapons/stunstick/stunstick_swing2.wav"))
	{
		if(IsValidEntity(entity)) //데매에선 엔티티가 클라이언트임.
		{
			//clients[64] = 0:콘솔, 1:콘솔, 
			//numClients = 콘솔로나옴
			//entity = 플레이어
			//PrintToChatAll("entity = %d", entity);
			//PrintToChatAll("entity = %N", entity);
			
			if(entity != -1)
			{
				if(IsClientConnectedIngame(entity))
				{
					if(GetClientTeam(entity) == ZOMBIE)
					{
						char Sound_String[256];
						Format(Sound_String, sizeof(Sound_String), "misc/zombi_swing_%i.wav", GetRandomInt(1, 3));
						// EmitSoundToAll(Sound_String, client);
						Sound(Sound_String, _, entity, true);
						Sound(Sound_String, _, entity); //개인만들림
					}
				}
			}
		}
		
		return Plugin_Handled;
	}
	//크로스보우:발사
	/* if(StrEqual(sample, "weapons/crossbow/fire1.wav"))
	{
		if(IsValidEntity(entity) && entity != -1) //데매에선 엔티티가 클라이언트임.
		{
			if(IsClientConnectedIngame(entity) && StrEqual(Current_Type[entity], "주둔병단", false))
			{
				decl Ammo;
				Ammo = FindDataMapInfo(entity, "m_iAmmo"); //FindDataMapOffs = FindDataMapInfo, HasEntProp(체크만할시)
				
				SetEntData(entity, Ammo + 24, 120, 4, true); //크로스보우
				
				//new String:Sound_String[256];
				//Format(Sound_String, 256, "giant/explosion.mp3");
				//EmitSoundToAll(Sound_String, entity);
				//return Plugin_Handled;
				Sound("giant/explosion.mp3", _, entity, true);
				Sound("giant/explosion.mp3", _, entity); //개인만들림
			}
		}
	} */
	return Plugin_Continue;
}

public void ZombieSkillUse(int Client)
{
	if(IsClientConnectedIngameAlive(Client))
	{
		if(GetClientTeam(Client) == ZOMBIE)
		{
			if(GetClientHealth(Client) > 500)
			{
				float nowtime = GetGameTime();
		
				if(ply[Client].runtime <= nowtime)
				{
					if(ply[Client].level == view_as<int>(Evo:Mother)) ply[Client].runtime = nowtime + 20.0;
					else ply[Client].runtime = nowtime + 30.0;
					
					SetEntProp(Client, Prop_Data, "m_iHealth", GetClientHealth(Client) - 500);
					//ClientCommand(Client, "r_screenoverlay zombie/zombovision.vmt");
					SetEntProp(Client, Prop_Send, "m_iFOV", 110);
					EmitSoundToAll("misc/zombi_pressure.wav", Client, SNDCHAN_AUTO, 80);
					SetEntityRenderColor(Client, 255, 0, 0, 255);
					SetEntPropFloat(Client, Prop_Data, "m_flLaggedMovementValue", 1.5);
					
					// ply[Client].runtimecount = 1;
					ply[Client].usingskill = true;
					CreateTimerEx(1.0, Rangesound, Client, TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE);
					// CreateTimerEx(5.0, RangeEnd, Client, TIMER_FLAG_NO_MAPCHANGE);
					
					//CreateTimerEx(1.0, MapIntCount, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
					// RangeSpeed[Client] = RangeSpeedSetting;
					// Range(Client);
					// ZombieSkillUse[Client] = true;
				}
				else
				{
					PrintCenterText(Client, "폭주스킬 준비시간 %.0f초", ply[Client].runtime - GetGameTime());
				}
			}
			else
			{
				PrintCenterText(Client, "체력이 부족합니다.");
			}
		}
	}
}
public Action Rangesound(any Client)
{
	if(IsClientConnectedIngameAlive(Client))
	{
		// Create a global variable visible only in the local scope (this function).
		static int count = 1;
		count++;
		
		int dd = GetRandomInt(0, 1);
		
		if(count == 2+1 || count == 4+1)
		{
			if(dd == 0) EmitSoundToAll("misc/zombi_pre_idle_1.wav", Client, SNDCHAN_AUTO, 80);
			else EmitSoundToAll("misc/zombi_pre_idle_2.wav", Client, SNDCHAN_AUTO, 80);
		}
		else if(count == 5+1)
		{
			// RangeSpeed[client] = 0.0;
			//ClientCommand(Client, "r_screenoverlay 0");
			SetEntProp(Client, Prop_Send, "m_iFOV", 90);
			SetEntityRenderColor(Client, 255, 255, 255, 255);
			SetEntPropFloat(Client, Prop_Data, "m_flLaggedMovementValue", 1.0);
			
			// ZombieSkillUse[client] = false;
			
			count = 0;
			// ply[Client].runtimecount = 0;
			ply[Client].usingskill = false;
			
			return Plugin_Stop;
		}
		
		return Plugin_Continue;
	}
	return Plugin_Stop;
}
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
// * 허드 : Hud. 
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬

// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
// * 타이머 : Timers. 
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
public Action MapIntCount()
{
	RoundCheck();
	HpRg();
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngame(Client)) 
		{
			RageHud(Client);
		}
	}
	return Plugin_Continue;
}
public void RageHud(int Client)
{
	// for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngame(Client)) 
		{
			if(GetClientTeam(Client) == ZOMBIE)
			{
				if(Hud_Rage[Client] != INVALID_HANDLE)
				{
					char HudString[256];
					int Int = ply[Client].level == view_as<int>(Evo:Host) ? SUPERMOTHERCOUNT : MOTHERCOUNT;
					float Calculate = (float(ply[Client].range) / float(Int)) * 100;
					Format(HudString, sizeof(HudString), "\n\n\n\nRage : %.0f％[%d/%d]", Calculate, ply[Client].range, Int);
					
					SetHudTextParams(0.45, 0.65, 1.0, 255, 0, 0, 0, 1);
					ShowSyncHudText(Client, Hud_Rage[Client], "%s", HudString);
				}
			}
		}
	}
	
}

public Action SetSpectate(Handle Timer, any Client)
{
	if(IsClientConnectedIngame(Client))
	{
		// ChangeClientTeam(Client, SPEC);
		ChangeClientTeam(Client, SPEC);
		SetEntProp(Client, Prop_Send, "m_iTeamNum", SPEC);
	}
	return Plugin_Handled;
}

public void RoundCheck()
{
	if(round.readytimer == -1)
	{
		if(!round.start) //게임 시작전
		{
			int Count = 0;
			for(int Client = 1; Client <= MaxClients; Client++)
			{
				if(IsClientConnectedIngame(Client))
				{
					Count++;
				}
			}
			SetHudTextParams(0.02, 0.79, 1.0, 255, 176, 0, 255);
			ShowHudTextAll("\n\n\n%d Waiting...", Count);
			
			if(Count > 1)
			{
				round.readytimer = 3;
			}
		}
		else //실게임 시작
		{
			//좀비 선출 카운트
			if(round.zombietimer > 0)
			{
				round.zombietimer--;
				if(round.zombietimer == 15) Sound("misc/zombi_start.wav");
				if(round.zombietimer <= 10)
				{
					char snd[64]; Format(snd, sizeof(snd), "misc/%d.wav", round.zombietimer);
					Sound(snd);
					// PrintToChatAll("%d초후 좀비 출현.", round.zombietimer);
					if(round.zombietimer == 0) //좀비 출현
					{
						// PrintToChatAll("좀비 출현! 4분 게임 시작");
						
						round.min = 3;
						round.sec = 30;
						
						SelectZombie(); //좀비 선출 함수
					}
				}
			}
			else //선출 완료 후
			{
				if(round.zombieborn) //좀비 선발후
				{
					round.sec--;
					if(round.sec < 0)
					{
						if(round.min > 0) 
						{
							round.min--;
							round.sec = 59;
						}
						else round.sec = 0;
					}
					
					// if(round.sec == 0 && round.min == 0) //게임종료
					{
						round.winner = GetWinnerTeam();
						if(round.winner != -1) Victory(round.winner);
						if(round.endtimer > 0) 
						{
							round.endtimer--;
							
							if(round.endtimer == 3)
							{
								ForceChangeTeamAll(SPEC);
							}
							if(round.endtimer == 1) ForceChangeTeamAll(HUMAN);
							if(round.endtimer == 0)
							{
								ServerCommand("mp_restartgame 1");
								round.zombieborn = false;
							}
						}	
					}
					
					SetHudTextParams(0.45, 0.65, 1.0, 255, 176, 0, 255);
					if(round.sec >= 10)
						ShowHudTextAll("\n\n\nTime Left  0%d : %d", round.min, round.sec);
					else
						ShowHudTextAll("\n\n\nTime Left  0%d : 0%d", round.min, round.sec);
				}
			}
		}
	}
	else if(round.readytimer > 0)
	{
		round.readytimer--;
		PrintCenterTextAll("%d초뒤 게임을 시작합니다.", round.readytimer);
		if(round.readytimer == 0) //한번
		{
			if(!round.start) 
			{
				round.start = true;
				round.readytimer = -1; //초기화
				round.zombietimer = 17;
				// PrintToChatAll("20초뒤 좀비가 출현합니다.");
			}
		}
	}
}

public void SelectZombie()
{
	if(!round.zombieborn) //좀비 선발전
	{
		round.zombieborn = true;
		
		int rand = GetRandomInt(1, 2);
		char snd[64]; Format(snd, sizeof(snd), "misc/zombi_coming_%d.wav", rand);
		Sound(snd);
		
		int Array = 0;
		int Clients[33] = {0, ...};

		for(int Client = 1; Client <= MaxClients; Client++)
		{
			if(IsClientConnectedIngame(Client) && IsPlayerAlive(Client))
			{
				Array++;
				Clients[Array] = Client;
				
				if(GetClientTeam(Client) == HUMAN)
				{
					//ClientCommand(Client, "r_screenoverlay icon/f_0.vmt");
				}
			}
		}

		if(Array > 0)
		{
			if(Array > 0 && Array <= 2) round.balance = 2;
			else if(Array > 0 && Array <= 4) round.balance = 3;
			else if(Array > 0 && Array <= 8) round.balance = 4;
			else if(Array > 0 && Array <= 12) round.balance = 6;
			else if(Array > 0 && Array <= 16) round.balance = 8;
			else if(Array > 0 && Array <= 32) round.balance = 10;
			
			for(int X = 0; X < Array / round.balance; X++)
			{
				int Client = Clients[GetRandomInt(1, Array)];

				if(IsClientConnectedIngame(Client) && IsPlayerAlive(Client))
				{
					if(!ply[Client].zombie)
					{
						ply[Client].zombie = true;
						ply[Client].level = view_as<int>(Evo:Host);
						
						SetEntProp(Client, Prop_Send, "m_iTeamNum", ZOMBIE);
						// GivePlayerItem(Client, "weapon_crowbar");
						
						SetEntityModel(Client, "models/stalker.mdl");
						SetEntProp(Client, Prop_Data, "m_iHealth", 7000, 1);  SetClientMaxHealth(Client, 7000);
						SetSpeed(Client, ZombieSpeed[Evo:Host]);
						PrintToChat(Client, "\x07You are a host zombie.!");
						
						//ClientCommand(Client, "r_screenoverlay 0");
						
						CreateTimer(0.0, InitializeWeapon, Client); //무기제거
						CreateTimer(0.2, GiveKnife, Client); //무기지급
					}
					else
					{
						X--;
					}
				}
			}
			// CreateTimer(1.0, TTT_Check, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

public Action InitializeWeapon(Handle Timer, any Client) //무기제거
{
	for(int X = 0; X < 47; X += 4)
	{
		int Weapon_Name = GetEntDataEnt2(Client, MyWeapon + X);

		if(Weapon_Name > MaxClients)
		{
			
			RemovePlayerItem(Client, Weapon_Name);
			RemoveEdict(Weapon_Name);
			// AcceptEntityInput(Weapon_Name, "Kill");
		
		}
	}
	return Plugin_Continue;
}
public Action GiveKnife(Handle Timer, any Client)
{
	if(IsClientConnectedIngameAlive(Client))
	{
		// GivePlayerItem(Client, "weapon_crowbar");
		GivePlayerItem(Client, "weapon_crowbar");
		if(GetClientTeam(Client) == HUMAN) 
		{
			GivePlayerItem(Client, "weapon_pistol");
			// GivePlayerItem(Client, "item_ammo_pistol_large");
			// GivePlayerItem(Client, "item_ammo_pistol_large");
			GivePlayerItem(Client, "weapon_smg1");
			GivePlayerItem(Client, "item_ammo_smg1_large");
			// GivePlayerItem(Client, "item_ammo_smg1_grenade");
			// GivePlayerItem(Client, "item_ammo_smg1_grenade");
			GivePlayerItem(Client, "item_ammo_smg1_grenade");
			GivePlayerItem(Client, "weapon_shotgun");
			// GivePlayerItem(Client, "item_box_buckshot");
			GivePlayerItem(Client, "item_box_buckshot");
			GivePlayerItem(Client, "weapon_ar2");
			GivePlayerItem(Client, "item_ammo_ar2_large");
			// GivePlayerItem(Client, "item_ammo_ar2_altfire");
			// GivePlayerItem(Client, "item_ammo_ar2_altfire");
			GivePlayerItem(Client, "item_ammo_ar2_altfire");
			GivePlayerItem(Client, "weapon_357");
			GivePlayerItem(Client, "item_ammo_357_large");
			GivePlayerItem(Client, "weapon_crossbow");
			// GivePlayerItem(Client, "item_ammo_crossbow");
			GivePlayerItem(Client, "weapon_slam");
			GivePlayerItem(Client, "weapon_rpg");
			GivePlayerItem(Client, "weapon_stunstick");
			// GivePlayerItem(Client, "weapon_physcannon");
			GivePlayerItem(Client, "weapon_frag");
		}
		else if(GetClientTeam(Client) == ZOMBIE)
		{
			SetWeaponsAlpha(Client, 0);
		}
		
		FakeClientCommandEx(Client, "use weapon_crossbow");
		
		//int ammooffset = FindDataMapOffs(Client, "m_iAmmo", 0, 0);
		int ammooffset = FindDataMapInfo(Client, "m_iAmmo"); //Ammo = FindDataMapInfo(entity, "m_iAmmo"); //FindDataMapOffs = FindDataMapInfo, HasEntProp(체크만할시)
		int iAmmo = 1000;
		int x = 4;
		while (x < 80)
		{
			if(x == 24) SetEntData(Client, x + ammooffset, 0, 4, true); //크로스보우
			else if(x == 8) SetEntData(Client, x + ammooffset, 10, 4, true); //AR2 코어볼
			else if(x == 36) SetEntData(Client, x + ammooffset, 20, 4, true); //SMG 유탄
			else SetEntData(Client, x + ammooffset, iAmmo, 4, true);
			x += 4;
		}
		// SetEntData(Client, Ammo + 4, 1, 4, true); //AR2
		// SetEntData(Client, Ammo + 8, 2, 4, true); //AR2 코어볼
		// SetEntData(Client, Ammo + 12, 3, 4, true); //피스톨
		// SetEntData(Client, Ammo + 16, 4, 4, true); //SMG
		// SetEntData(Client, Ammo + 20, 5, 4, true); //357
		// SetEntData(Client, Ammo + 24, 6, 4, true); //크로스보우
		// SetEntData(Client, Ammo + 28, 7, true); //샷건
		// SetEntData(Client, Ammo + 32, 8, 4, true); //RPG
		// SetEntData(Client, Ammo + 36, 9, 4, true); //SMG 유탄
		// SetEntData(Client, Ammo + 40, 10, 4, true); //수류탄
		// SetEntData(Client, Ammo + 44, 11, 4, true); //슬램
		
		
		int offset_Active = 1896;
		int offset_Clip = 1204;
		int ammo = GetEntDataEnt2(Client, offset_Active);
		if(ammo != -1) SetEntData(ammo, offset_Clip, 1000, 4, true);
		// PrintToChat(Client, "\x03[\x04LcF\x03] \x04모든 무기 및 탄약 1000발 적용완료!");
		
		int m_hMyWeapons = FindSendPropInfo("CBasePlayer", "m_hMyWeapons"); 

		for (int i = 0, weapon; i < 47; i += 4)
		{
			weapon = GetEntDataEnt2(Client, m_hMyWeapons + i);

			if (weapon != -1) //잘되긴하는데 가끔 안되는게 잇음
			{
				SetEntProp(weapon, Prop_Data, "m_iClip1", 1000);
				SetEntityRenderMode(weapon, RENDER_TRANSCOLOR);
			}
		}

		ChangeEdictState(Client);
	}
	return Plugin_Handled;
}

public int GetWinnerTeam()
{
	int HCount = 0, ZCount = 0;
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngameAlive(Client))
		{
			if(GetClientTeam(Client) == HUMAN)
			{
				HCount++;
			}
			if(GetClientTeam(Client) == ZOMBIE)
			{
				ZCount++;
			}
		}
	}
	if(round.sec == 0 && round.min == 0)
	{
		if(HCount > 0) return HUMAN;
		else if(HCount == 0) return ZOMBIE;
		else if(ZCount == 0) return HUMAN;
		else return -1;
	}
	else if(round.sec > 0 && round.min >= 0) //게임 진행중 좀비 멸망 아니면 안끝냄
	{
		if(HCount == 0) return ZOMBIE;
		else if(ZCount == 0) 
		{
			return HUMAN;
		}
		else return -1;
	}
	else return -1;
	
}

public void Victory(int WinTeam)
{
	if(round.endtimer == -1) 
	{
		
		round.endtimer = 5;
		// PrintToChatAll("게임종료, 이긴팀 : %s", round.winner == HUMAN ? "인간":"좀비");
		
		if(WinTeam == HUMAN)
		{
			EmitSoundToAll("misc/win_human_2.wav");
			for(new i = 1; i <= MaxClients; i++)
			{
				if(IsClientConnectedIngame(i))
				{
					Clientovverride(i, "zombie/humanwin.vmt", 5.0);
				}
			}
		}
		else //좀비윈
		{
			EmitSoundToAll("misc/win_zombi_2.wav");
			for(new i = 1; i <= MaxClients; i++)
			{
				if(IsClientConnectedIngame(i))
				{
					Clientovverride(i, "zombie/zombiewin.vmt", 5.0);
				}
			}
		}
	}
}

public void ForceChangeTeamAll(int Team)
{
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngame(Client))
		{
			SetEntProp(Client, Prop_Send, "m_iTeamNum", Team);
		}
	}
}

public void HpRg()
{
	for(int Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngameAlive(Client) && GetClientTeam(Client) == ZOMBIE)
		{
			int hp = GetClientHealth(Client), maxhp = GetClientMaxHealth(Client);
			if(!ply[Client].healmode && hp < maxhp)
			{
				if(ply[Client].healmodecount <= 4)
				{
					ply[Client].healmodecount++;
					if(ply[Client].healmodecount == 4)
					{
						ply[Client].healmode = true;
					}
				}
			}
			else if(ply[Client].healmode) //힐시작
			{
				if(IsZombieSpeedZero(Client) && hp < maxhp)
				{
					if(IsZombieHealthMinimum(Client))
					{
						EmitSoundToClient(Client, "misc/zombi_heal.wav");
						SetEntProp(Client, Prop_Data, "m_iHealth", GetClientHealth(Client) + (GetClientMaxHealth(Client) / 20));
					}
					else
					{
						EmitSoundToClient(Client, "misc/zombi_heal.wav");
						SetEntProp(Client, Prop_Data, "m_iHealth", GetClientMaxHealth(Client));
						
						ply[Client].healmode = false;
						ply[Client].healmodecount = 0;
					}
				}
				else
				{
					ply[Client].healmode = false;
					ply[Client].healmodecount = 0;
				}					
			}
		}
	}
}

public void ForceChangeKnife(int Client)
{
	if(IsClientConnectedIngame(Client) && GetClientTeam(Client) == ZOMBIE)
	{
		char WeaponClass[32];
		GetClientWeapon(Client, WeaponClass, sizeof(WeaponClass));
		if(!StrEqual(WeaponClass, "weapon_crowbar", false)) FakeClientCommandEx(Client, "use weapon_crowbar");
	}
}
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
// * 커맨드 : 
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬

// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
// * 스톡 : 
// * ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
stock bool:IsClientConnectedIngame(client){
	if(client > 0 && client <= MaxClients){
		if(IsClientConnected(client) == true){
			if(IsClientInGame(client) == true){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}
}
stock bool:IsClientConnectedIngameAlive(client)
{
	if(IsClientConnectedIngame(client)){
	
		if(IsPlayerAlive(client) == true && IsClientObserver(client) == false){
					
			return true;
		
		}else{
		
			return false;
	
		}
		
	}else{
		
		return false;
	
	}
}
stock bool:IsClientAlive(Client)
{
	if(Client > 0 && Client <= MaxClients)
	{
		if(IsClientInGame(Client))
		{
			if(IsPlayerAlive(Client))
			{
				return true;
			}
		}
	}
	return false;
}
public bool:AliveCheck(Client)
{
	if(Client > 0 && Client <= MaxClients)
		if(IsClientConnected(Client) == true)
			if(IsClientInGame(Client) == true)
				if(IsPlayerAlive(Client) == true) return true;
				else return false;
			else return false;
		else return false;
	else return false;
}
stock bool:IsPlayerWithin(Client, Entity, Data)
{
  decl Float:ClientOrigin[3];
  decl Float:EntityOrigin[3];
  
  GetEntPropVector(Client, Prop_Send, "m_vecOrigin", ClientOrigin);
  GetEntPropVector(Entity, Prop_Send, "m_vecOrigin", EntityOrigin);
  
  decl Float:DistanceOrigin;
  DistanceOrigin = GetVectorDistance(ClientOrigin, EntityOrigin);
  
  if(DistanceOrigin <= Data)
  {
    return true;
  } 
  
  return false;
}
stock ShowHudTextAll(const String:Format[], any:...)
{
	char Buffer[256];
	
	for(new Client = 1; Client <= MaxClients; Client++)
	{
		if(IsClientConnectedIngame(Client))
		{
			SetGlobalTransTarget(Client);
			VFormat(Buffer, sizeof(Buffer), Format, 2);
			
			ShowHudText(Client, -1, "%s", Buffer);
		}
	}
}
/** 사운드스톡:파천지교
 * 사운드를 보다 편리하게 출력시키도록 도와주는 함수
 *
 * @param Path      사운드의 경로
 * @param Vol			사운드의 볼륨 크기
 * @param Client			특정 클라이언트
 * @param Origin      클라이언트 주변 설정
 * @error				유효하지 않는 클라이언트
 */
stock Sound(const String:Path_[], Float:Vol=1.0, Client=0, bool:Origin=false)
{
	//To All (Volume : 1.0)
	//Sound("sound/test.mp3");
	
	//To All (Volume : 1.5)
	//Sound("sound/test.mp3", 1.5);
	
	//To Client (Volume : 1.0)
	//Sound("sound/test.mp3", _, Client);
	
	//To Client and Near of Client (Volume : 1.0)
	//Sound("ambient/energy/whiteflash.wav", _, Client, true);
	PrecacheSound(Path_, true);

	if(Client == 0)
	{
		EmitSoundToAll(Path_, SOUND_FROM_PLAYER, _, _, _, Vol);
	}
	else
	{
		if(Origin)
		{
			if(IsClientConnected(Client) && IsPlayerAlive(Client))
			{
				decl Float:ClientOrigin[3];
				GetClientAbsOrigin(Client, ClientOrigin);

				EmitSoundToAll(Path_, SOUND_FROM_WORLD, _, _, _, Vol, _, _, ClientOrigin);
			}
		}
		else
		{
			EmitSoundToClient(Client, Path_, SOUND_FROM_PLAYER, _, _, _, Vol);
		}
	}
}

public ItemRemoveEntity()
{
  for(new X = MaxClients, Y = GetMaxEntities(); X < Y; X++)
  {
    if(IsValidEdict(X) && IsValidEntity(X))
    {
      decl String:Entity[64];
      GetEdictClassname(X, Entity, sizeof(Entity));

      if(StrContains(Entity, "weapon_") != -1 || StrContains(Entity, "item_") != -1)
      {
        decl Parents;
        Parents = GetEntPropEnt(X, Prop_Send, "m_hOwnerEntity");
        
        if(Parents == -1)
        {
          RemoveEdict(X);
        }
      }
    }
  }
}

stock Clientovverride(client, const String:buffer[], Float:sec = 5.0)
{
	if(IsClientConnectedIngame(client))
	{
		DispatchKeyValue(client, "TargetName", "true");
		//ClientCommand(client, "r_screenoverlay %s", buffer);
		CreateTimer(sec, deleteover, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:deleteover(Handle:timer, any:client)
{
	if(IsClientConnectedIngame(client))
	{
		//ClientCommand(client, "r_screenoverlay 0");
		DispatchKeyValue(client, "TargetName", "");
	}
	return Plugin_Stop;
}
stock bool:IsClientAdmin(Client)
{
	new AdminId:IsAdmin;
	IsAdmin = GetUserAdmin(Client);
	if(IsAdmin == INVALID_ADMIN_ID)return false;
	else return true;
}
SetWeaponsAlpha(Client, alpha) // 이 함수 안에서 무기 투명화를 진행합니다
{
	if(IsPlayerAlive(Client)) // 읭읭 클라이언트가 살아있다면!?
	{
		new m_hMyWeapons = FindSendPropInfo("CBasePlayer", "m_hMyWeapons");
		for(new i = 0, weapon; i < 47; i += 4) // 웨펀을 다 맞춰보는 건데 i += 4 이부분은 오프셋이 4 단위로 커지기 때문입니다.
		{
			weapon = GetEntDataEnt2(Client, m_hMyWeapons + i);// 엔티티데이터를 weapon 으로옮긴다
		
			if(weapon > -1 ) // 적어도 하나의 무기를 손에 들고있다!?
			{
				SetEntityRenderMode(weapon, RENDER_TRANSCOLOR); // 무기의 렌더링 타입 세팅
				SetEntityRenderColor(weapon, 255, 255, 255, alpha); // 여기서 무기색상 코드를 제시하자
			}
		}
	}
}
stock bool IsZombieSpeedZero(int client)
{
	float playerspeed[3];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);

	if(playerspeed[0] == 0.0 && playerspeed[1] == 0.0 && playerspeed[2] == 0.0)
	{
		return true;
	}
	return false;
}
stock bool:IsZombieHealthMinimum(client)
{
	if(GetClientHealth(client) < GetClientMaxHealth(client) 
	&& (GetClientHealth(client) + (GetClientMaxHealth(client) / 20)) < GetClientMaxHealth(client))
	{
		return true;
	}
	return false;
}
public SetClientMaxHealth(client, value)
{
	SetEntProp(client, Prop_Data, "m_iMaxHealth", value);
}
public GetClientMaxHealth(client)
{
	return GetEntProp(client, Prop_Data, "m_iMaxHealth");
}


stock CreateSprite(Client, String:sprite[], Float:height, Numb)
{
	decl Float:clientposition[3];
	GetClientAbsOrigin(Client, clientposition);
	clientposition[2] = clientposition[2] + height;
	new String:positionstring[128];
	Format(positionstring, 128, "%f %f %f", clientposition[0], clientposition[1], clientposition[2]);

	Envsprite[Client][Numb] = CreateEntityByName("env_sprite_oriented");
	if(Envsprite[Client][Numb])
	{
		DispatchKeyValue(Envsprite[Client][Numb], "model", sprite);
		DispatchKeyValue(Envsprite[Client][Numb], "Origin", positionstring);
		DispatchKeyValue(Envsprite[Client][Numb], "classname", "env_sprite_oriented");
		DispatchKeyValue(Envsprite[Client][Numb], "spawnflags", "1");
		DispatchKeyValue(Envsprite[Client][Numb], "scale", "0.1");
		DispatchKeyValue(Envsprite[Client][Numb], "rendermode", "1");
		DispatchKeyValue(Envsprite[Client][Numb], "rendercolor", "255 255 255");
		DispatchSpawn(Envsprite[Client][Numb]);
		AcceptEntityInput(Envsprite[Client][Numb], "ShowSprite");
							
		SetVariantString("!activator");
		AcceptEntityInput(Envsprite[Client][Numb], "SetParent", Client);
		SetEntPropEnt(Envsprite[Client][Numb], Prop_Send, "m_hOwnerEntity", Client);

		SDKHook(Envsprite[Client][Numb], SDKHook_SetTransmit, transmit);
	}
}
public Action:transmit(entity, client)
{
	new onwer = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");

	if(onwer == client) //&& GetClientTeam(client) != 1 GetClientTeam(onwer) != GetClientTeam(client) || 
	{
		return Plugin_Handled;
	}
	return Plugin_Continue;
}
stock RemoveSprite(Client, Numb)
{
	if(Envsprite[Client][Numb] != 0 && EntRefToEntIndex(Envsprite[Client][Numb]) != 0)
	{
		if(IsValidEntity(Envsprite[Client][Numb]) == true)
		{
			SDKUnhook(Envsprite[Client][Numb], SDKHook_SetTransmit, transmit);
			new String:classname[32];
			GetEdictClassname(Envsprite[Client][Numb], classname, sizeof(classname));
	
			if(StrEqual(classname, "env_sprite_oriented", false))
			{
				AcceptEntityInput(Envsprite[Client][Numb], "Kill");
			}

			Envsprite[Client][Numb] = 0;
		}
	}
}

stock CreateVMT(Float:pos[3], const String:Model[], Float:size, const String:rate[], Float:del)
{
	new sprite = CreateEntityByName("env_sprite");

	if(!IsModelPrecached(Model))
	{
		PrecacheModel(Model, true);
	}

	new String:spritename[128];
	Format(spritename, 128, "sprite%d%f", GetURandomInt(), GetRandomFloat());
	DispatchKeyValue(sprite, "targetname", spritename);
	DispatchKeyValueFloat(sprite, "HDRColorScale", 1.0);
	DispatchKeyValue(sprite, "renderamt", "255");
	DispatchKeyValue(sprite, "rendercolor", "255 255 255");
	//DispatchKeyValueVector(sprite, "angles", angle);
	DispatchKeyValue(sprite, "spawnflags", "1");
	DispatchKeyValue(sprite, "rendermode", "5");
	DispatchKeyValue(sprite, "model", Model);
	DispatchKeyValue(sprite, "framerate", rate);
	DispatchKeyValueFloat(sprite, "scale", size);
	DispatchSpawn(sprite);
	AcceptEntityInput(sprite, "ShowSprite");
	TeleportEntity(sprite, pos, NULL_VECTOR, NULL_VECTOR);
	//PrintToChatAll("sprite pos: %.1f %.1f %.1f index: ", pos[0], pos[1], pos[2], sprite);
	new String:output[512];
	Format(output, 512, "OnUser1 !self:kill:justkill:%f:1", del);	
	SetVariantString(output);
	AcceptEntityInput(sprite, "AddOutput");
	AcceptEntityInput(sprite, "FireUser1");
}
stock Float:IntToFloat(i_Int)
{
	decl String:s_Int[256];
	Format(s_Int, sizeof(s_Int), "%d.0", i_Int);
	return StringToFloat(s_Int);
}
stock FloatToInt(Float:f_Float)
{
	decl String:s_Float[256];
	FloatToString(f_Float, s_Float, sizeof(s_Float));
	return StringToInt(s_Float);
}
stock void SetClientButtons(client, buttons){
	
	SetEntProp(client, Prop_Data, "m_nButtons", buttons);
	
}

/*
 * Set's a clients speed
 * @param Client Player to use
 * @param Speed Speed to use, Speed Cannot exceed 320.0 in HL2DM
 */
stock void SetSpeed(int Client, float Speed)
{
	//Initialize:
	int SpeedOffset = FindSendPropInfo("CHL2MP_Player", "m_flMaxspeed");

	//Set Speed:
	if(SpeedOffset > 0) SetEntData(Client, SpeedOffset, Speed, 4, true);
}
stock float GetSpeed(int Client)
{
	//Initialize:
	int SpeedOffset = FindSendPropInfo("CHL2MP_Player", "m_flMaxspeed");
	//Set Speed:
	if(SpeedOffset > 0) return view_as<float>(GetEntData(Client, SpeedOffset));
	return 0.0;
}